<?php

namespace DataView;

class Fop_mail_host_box_dir_email_thread_email {
  
  

  
  

    // --- Statische Methoden ---
  
  public static function renderTabTableAction($id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
     ?><div class='fop-dv-buttonbar'><?php if(((false))) { ?><a class="mdl-button mdl-js-button mdl-button--raised mdl-button--colored" onclick="var self = this; $.get(reloadfop_mail_host_box_dir_email_thread_email({action: 'open', fop_table: 'fop_mail_host_box_dir_email_thread', fop_id: '_', fop_from: location.href}, true)).then(function () { open_url(self.href, false);}); return false;" href="<?php echo htmlentities(\TablesRouter\Fop_mail_host_box_dir_email_thread::createURL2(['from' => \FOP\Util::getBackUrl(), 'column_email' => $id])); ?>"><i class="material-icons">add</i> <?php echo(sprintf(_('create %s'), _('emaildirectorythread_singular'))); ?></a><?php } ?></div><?php 
								\FOP\User::getIsGuest();
								$itemheight = 32;
								$itemsperpage = ceil(1080 / $itemheight * 0.8);
								$page = (isset($_GET['page_fop_mail_host_box_dir_email_thread_email']) ? intval($_GET['page_fop_mail_host_box_dir_email_thread_email']) : 0);
								$addlines = (isset($_GET['addlines_fop_mail_host_box_dir_email_thread_email']) ? intval($_GET['addlines_fop_mail_host_box_dir_email_thread_email']) : 0);
								$firstitem = $page * $itemsperpage;
								$sqladdon = ' LIMIT ' . ($itemsperpage * 2) . ' OFFSET ' . ($firstitem);
								$data = self::getData($sqladdon, $_GET, $id);
								$arr = $data["items"];
								$itemcount = $data["itemcount"];
								$lastPage = ceil($itemcount/$itemsperpage-1);
								// calculate width of first column: 67px + 32px for each shortcut
								$firstColumnWidth = 66 + 34 + 34;
								$additionalLines = 0;

									// Spaltenliste zuerst aufbauen, damit sie noch umsortiert werden kann
									$order = 1000;
									$columns = [];
									
										if(true){
											$col = [
												'id' => 'refemail',
												'desc' => _('Kommunikationsverlauf'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['refemail'] = $col;
										}
									

									// gespeicherte Spaltenanordnung
									foreach (\FOP\Database::query('SELECT * FROM fop_dataview WHERE '.qi('user').' = ' . \FOP\Database::quote(\FOP\User::getID()) . ' AND dataview = ' . \FOP\Database::quote('fop_mail_host_box_dir_email_thread_email'))->fetchAll(\PDO::FETCH_ASSOC) AS $column => $c) {
										if (isset($columns[$c['column']])) {
											$columns[$c['column']]['order'] = $c['order']; // order, width, collapsed
											$columns[$c['column']]['width'] = $c['width']; // order, width, collapsed
											$columns[$c['column']]['collapsed'] = $c['collapsed']; // order, width, collapsed
										}
									}

									// DOM vor-rendern
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='refemail'
												data-order='<?php echo intval($columns['refemail']['order']); ?>'
												data-width='<?php echo intval($columns['refemail']['width']); ?>'
												data-collapsed='<?php echo intval($columns['refemail']['collapsed']); ?>'
												style='width: <?php echo intval($columns['refemail']['width']); ?>px; <?php if ($columns['refemail']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_mail_host_box_dir_email_thread_email(); 
		}});
		
		win.append(getfilter_fop_mail_host_box_dir_email_thread_email_refemailListMultiFilter()); win.find('input').first().focus();
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_mail_host_box_dir_email_thread_email'] == 'refemail ASC') {
			query['sort_fop_mail_host_box_dir_email_thread_email'] = 'refemail DESC';
		 } else if (query['sort_fop_mail_host_box_dir_email_thread_email'] == 'refemail DESC') {
		 	delete query['sort_fop_mail_host_box_dir_email_thread_email'];
		 } else {
			query['sort_fop_mail_host_box_dir_email_thread_email'] = 'refemail ASC';
		 }
		 reloadfop_mail_host_box_dir_email_thread_email();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('Kommunikationsverlauf')); ?>'><?php echo(_('Kommunikationsverlauf')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_mail_host_box_dir_email_thread_email']) && $_GET['sort_fop_mail_host_box_dir_email_thread_email'] == 'refemail ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_mail_host_box_dir_email_thread_email']) && $_GET['sort_fop_mail_host_box_dir_email_thread_email'] == 'refemail DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_mail_host_box_dir_email_thread_email_refemail']) || isset($_GET['range_max_fop_mail_host_box_dir_email_thread_email_refemail']) || isset($_GET['deps_fop_mail_host_box_dir_email_thread_email_refemail']) || isset($_GET['fullsearch_fop_mail_host_box_dir_email_thread_email_refemail']) || isset($_GET['dynamic_fop_mail_host_box_dir_email_thread_email_refemail']) || isset($_GET['search_fop_mail_host_box_dir_email_thread_email_refemail']) || isset($_GET['searchnot_fop_mail_host_box_dir_email_thread_email_refemail']) || isset($_GET['filter_fop_mail_host_box_dir_email_thread_email_refemail'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['refemail']['header'] = ob_get_contents(); ob_end_clean();
											$columns['refemail']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['refemail']['width']); ?>px; <?php if ($columns['refemail']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='refemail'><?php
	
	call_user_func(function () use ($item) {
	$id = $item['refemail'];
	$val = $item['refemail::description'];
	$canView = $item['refemail::canView'];
	if ($val !== null) {
		if ($canView) echo "<a tabindex=\"-1\" class=\"mdl-button mdl-button-small tbl-link\" data-tbl=\"fop_mail_host_box_dir_email\" data-id=\"".htmlentities($id)."\" onclick=\"event.stopPropagation(); event.preventDefault(); open_url(this.href, false);\" href=\"" . \TablesRouter\Fop_mail_host_box_dir_email::viewURL($id, ['from' => \FOP\Util::getBackURL()]) . "\">(…)</a>";echo htmlentities($val);
	} else {
		echo htmlentities(_('') ?: '-');
	}
	});
	
?>
</div><?php
											};
											$columns['refemail']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='refemail'
													data-order='<?php echo intval($columns['refemail']['order']); ?>'
													data-width='<?php echo intval($columns['refemail']['width']); ?>'
													data-collapsed='<?php echo intval($columns['refemail']['collapsed']); ?>'
													style='width: <?php echo intval($columns['refemail']['width']); ?>px; <?php if ($columns['refemail']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									

									// sort by order
									uasort($columns, function ($a, $b) {
										return $a['order'] - $b['order'];
									});
									?>
									<style type='text/css'>
										#fop_mail_host_box_dir_email_thread_email-table .fop-table-header {
											height: <?php echo 32; ?>px;
										}
										#fop_mail_host_box_dir_email_thread_email-table .fop-table-header .fop-table-column .title,
										#fop_mail_host_box_dir_email_thread_email-table .fop-column-handle,
										#fop_mail_host_box_dir_email_thread_email-table .fop-table-row,
										#fop_mail_host_box_dir_email_thread_email-table .fop-table-row .fop-table-column,
										#fop_mail_host_box_dir_email_thread_email-table .fop-table-column-multicontrol,
										#fop_mail_host_box_dir_email_thread_email-table .fop-filter-button {
											height: 32px;
											line-height: 32px;
										}
										</style>
											<div class="fop-table" data-table-id="fop_mail_host_box_dir_email_thread_email">
											<div class="fop-legend"></div>
											<div class="fop-filter-string-wrapper"><div class="fop-filter-string"><label>Filter:</label> <span><?php echo self::getFilterHTML($_GET); ?></span></div></div>
											
											<?php if (isset($_GET['select'])) { echo '<br>'; } ?>
											<div class="fop-table-header">
											<?php if (!isset($_GET['select'])) { ?>
												<div class="fop-table-column noprint" style="width: <?php echo json_encode($firstColumnWidth); ?>px;">
													
													<div class="fop-table-column-multicontrol">
													<label class="mdl-checkbox mdl-js-checkbox"  style='width: auto;' for="fop_mail_host_box_dir_email_thread_email__all-checkbox">
														<input class="mdl-checkbox__input" id="fop_mail_host_box_dir_email_thread_email__all-checkbox" type="checkbox" onchange="checkfop_mail_host_box_dir_email_thread_email('all', 'ID', this.checked);">
														</label>
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon fop_mail_host_box_dir_email_thread_email__mass-action" style='visibility: hidden;' onclick="$.get('DataView/Fop_mail_host_box_dir_email_thread_email/permissions?id=' + checkfop_mail_host_box_dir_email_thread_email(null, 'ID'), function (data) { for (var method in data) if (method != '__cnt') { var btn = $('[data-interaction-name=&quot;' + method + '&quot;]'); if (data[method] >= 1) btn.show(); else btn.hide(); btn.find('.cnt').text(data[method]); }; }); dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">more_vert</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterall" style="margin-right:auto; text-align:left;"
					onclick="for (key in query) if (key.indexOf('range_min_fop_mail_host_box_dir_email_thread_email_') == 0 || key.indexOf('range_max_fop_mail_host_box_dir_email_thread_email_') == 0 || key.indexOf('deps_fop_mail_host_box_dir_email_thread_email_') == 0 || key.indexOf('fullsearch_fop_mail_host_box_dir_email_thread_email_') == 0 || key.indexOf('dynamic_fop_mail_host_box_dir_email_thread_email_') == 0 || key.indexOf('search_fop_mail_host_box_dir_email_thread_email_') == 0 || key.indexOf('searchnot_fop_mail_host_box_dir_email_thread_email_') == 0 || key.indexOf('filter_fop_mail_host_box_dir_email_thread_email_') == 0) delete query[key]; reloadfop_mail_host_box_dir_email_thread_email(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">list</i></span><span class="fop-menu-caption" title="<?php echo(_('view all elements')); ?>"><?php echo(_('view all elements')); ?> 
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filteronly" style="margin-right:auto; text-align:left;"
					onclick="query['filter_fop_mail_host_box_dir_email_thread_email_ID'] = checkfop_mail_host_box_dir_email_thread_email(null, 'ID'); delete query['page_fop_mail_host_box_dir_email_thread_email']; reloadfop_mail_host_box_dir_email_thread_email(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">arrow_forward</i></span><span class="fop-menu-caption" title="<?php echo(_('view only these elements')); ?>"><?php echo(_('view only these elements')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterrange" style="margin-right:auto; text-align:left;"
					onclick="
		var ticks = new IDList(checkfop_mail_host_box_dir_email_thread_email(null, 'ID'));
		var range = prompt('Bitte geben Sie den Bereich ein', '1-' + ticks.count());
		var newticks = new IDList();
		if (range) {
			range = range.split('-');
			if (range.length == 1) {
				range.push(range[0]);
			}
			var skip = (range[0] || 1) - 1;
			var take = (range[1] || Infinity) - skip;
			for (var item of ticks.all()) {
				if (skip > 0) {
					skip--;
				} else if (take > 0) {
					newticks.push(item);
					take--;
				} else break;
			}
			checkfop_mail_host_box_dir_email_thread_email(newticks, 'ID', 'set');
		} $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">colorize</i></span><span class="fop-menu-caption" title="<?php echo(_('limit range')); ?>"><?php echo(_('limit range')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true && ((false))) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;"
					onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return;$.get('Tables/Fop_mail_host_box_dir_email_thread/delete?ajax&from=<?php echo urlencode(\FOP\Util::getBackUrl()); ?>&id=' + escape(checkfop_mail_host_box_dir_email_thread_email(null, 'ID'))).then(function () { reloadfop_mail_host_box_dir_email_thread_email(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?>
														</ul>
														<!-- column hide -->
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon" onclick="dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">visibility</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php foreach ($columns AS $col) { ?>
																<li class="mdl-list__item mdl-button" onclick="
																	var isVisible = this.firstElementChild.innerText !== 'clear';
																	this.firstElementChild.innerText = isVisible ? 'clear' : 'visibility'; // switch icon
																	tableColumnVisibility('fop_mail_host_box_dir_email_thread_email', <?php echo htmlentities(json_encode($col['id'])); ?>, !isVisible); // the rest is up to a helper function in layout/tables.fop
																	">
																	<i class="material-icons"><?php if ($col['collapsed']) { echo 'clear'; } else { echo 'visibility'; }?></i>
																	<?php echo htmlentities($col['desc']); ?>
																</li>
															<?php } ?>
															<li class="mdl-list__item mdl-button" onclick="
																$.get('FOP/Index/dataview?data='+encodeURIComponent(JSON.stringify({dataview: 'fop_mail_host_box_dir_email_thread_email', reset: true}))).then(function () { location.reload(); });
																">
																<i class="material-icons">refresh</i>
																<?php echo _('reset all'); ?>
															</li>
														</ul>
													</div>
												</div><?php }
												
												foreach ($columns AS $col) {
													// Spalten-Überschrift rendern
													echo $col['header'];
												} ?>
											 </div>
											
											<div class="fop-table-body" id="table_fop_mail_host_box_dir_email_thread_email" <?php \EasyEditor\Navigation::printScroll('dv.Fop_mail_host_box_dir_email_thread_email', '/* scroll horiz */ this.previousElementSibling.firstElementChild.style.marginLeft = \'-\' + this.scrollLeft + \'px\';
												/* scroll verti */
												var self = this;
												if (window.DataViewScrollReloadTimeout) clearTimeout(window.DataViewScrollReloadTimeout);
												window.DataViewScrollReloadTimeout = setTimeout(function () {
													var currentPage = parseInt(query[\'page_fop_mail_host_box_dir_email_thread_email\'] || 0);
													var paddingTop = parseInt( self.lastElementChild.style.paddingTop, 10);
													var wantedPage = Math.max(0, currentPage + Math.floor((self.scrollTop - paddingTop) / ' . ($itemheight * $itemsperpage) . '));
													if (wantedPage != currentPage) {
														query[\'page_fop_mail_host_box_dir_email_thread_email\'] = wantedPage;
														reloadfop_mail_host_box_dir_email_thread_email(undefined, undefined, true);
													}
												}, 50);
											'); ?>>
												<div class="fop-table-body-inner" style="min-height: <?php echo 12 + $itemheight * ($itemcount + $additionalLines); ?>px; padding-top: <?php echo $itemheight * $itemsperpage * $page; ?>px;">
												<?php foreach($arr as $itempos => $item) {
													?>
													<div class="fop-table-row" style="" data-fop_mail_host_box_dir_email_thread-id="<?php echo htmlentities($item['ID']); ?>">

													<?php if (!isset($_GET['select'])) { ?>
													<div class='fop-table-column noprint' style="width: <?php echo json_encode($firstColumnWidth); ?>px;" onclick="$(this).find('input[type=checkbox]').first().click(); event.stopPropagation();">
													<label onclick="event.stopPropagation();" class="mdl-checkbox mdl-js-checkbox fop_mail_host_box_dir_email_thread_email__checkbox fop_mail_host_box_dir_email_thread_email__checkbox fop_mail_host_box_dir_email_thread_email__checkbox-ID-<?php echo htmlentities($item['ID']); ?>" style="width: auto;" for="fop_mail_host_box_dir_email_thread_email__<?php echo htmlentities($itempos); ?>-checkbox">
													<input class="mdl-checkbox__input" id="fop_mail_host_box_dir_email_thread_email__<?php echo htmlentities($itempos); ?>-checkbox" type="checkbox" onchange="<?php if (isset($item['ID'])) echo 'checkfop_mail_host_box_dir_email_thread_email(' . htmlentities(json_encode($item['ID'])) . ', \'ID\', this.checked); ' ?>">
													</label><button type="button" class="mdl-button mdl-js-button mdl-button--icon fop_mail_host_box_dir_email_thread_email__action" onclick="
														event.stopPropagation();
														dropDownFixPosition($(this), $(this).next());
														">
														<i class="material-icons">more_vert</i>
													</button><ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu" id="fop-scroll-menu-fop_mail_host_box_dir_email_thread_email-action-<?php echo $item['ID'] ?? 0; ?>">
														<?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="edit" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\Fop_mail_host_box_dir_email_thread::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="   
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">edit</i></span><span class="fop-menu-caption" title="<?php echo(_('edit')); ?>"><?php echo(_('edit')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::delete']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;" href="#"
				onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return false;   $.get('Tables/Fop_mail_host_box_dir_email_thread/delete?ajax&id=<?php echo htmlentities($item['ID']);?>&from=<?php echo htmlentities(\FOP\Util::getBackUrl());?>').then(function () { reloadfop_mail_host_box_dir_email_thread_email(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?></span>
			</a>
		<?php } ?>
													</ul><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="fop_mail_host_box_dir_email_thread" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="edit" href="<?php echo htmlentities(\TablesRouter\Fop_mail_host_box_dir_email_thread::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();    reloadfop_mail_host_box_dir_email_thread_email();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('edit')); ?>">
				<i class="material-icons">edit</i>
			</a><?php } ?>
													</div><?php } ?><?php
													
													foreach ($columns AS $col) {
														$col['render']($item);
													}
													?></div>
												 <?php }?>

													</div>
												</div>

												
												
												</div><?php
												
	
    
  }

  public static function renderScript($id) { 
    
    
    // --- BLOCK: main ---
    
								\FOP\I18n::ensureIsLoaded();
								?>
								<script type="text/javascript">
									
    function changefilter_fop_mail_host_box_dir_email_thread_email_emailListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_fop_mail_host_box_dir_email_thread_email_email', val, cb.checked);
		  } else {
			  delete query['filter_fop_mail_host_box_dir_email_thread_email_email'];
		  }reloadfop_mail_host_box_dir_email_thread_email();
        
    }

		var i1c3011bf1b9427a4a9ed9b7d431bb953201ae52dfb57211f4cbca57dcea0c7d9timeout = null;
		function changefilter_fop_mail_host_box_dir_email_thread_email_emailSearchFilter(val, callback) {
			if(i1c3011bf1b9427a4a9ed9b7d431bb953201ae52dfb57211f4cbca57dcea0c7d9timeout) clearTimeout(i1c3011bf1b9427a4a9ed9b7d431bb953201ae52dfb57211f4cbca57dcea0c7d9timeout);

			i1c3011bf1b9427a4a9ed9b7d431bb953201ae52dfb57211f4cbca57dcea0c7d9timeout = setTimeout(function() {
				$.getJSON(reloadfop_mail_host_box_dir_email_thread_email({action: 'getfilter_fop_mail_host_box_dir_email_thread_email_emailItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_fop_mail_host_box_dir_email_thread_email_email_orig'] = val;
				});
			}, 300);
		}

	function getfilter_fop_mail_host_box_dir_email_thread_email_emailListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_fop_mail_host_box_dir_email_thread_email_email_orig']) ? json_encode($_GET['filter_fop_mail_host_box_dir_email_thread_email_email_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="1c3011bf1b9427a4a9ed9b7d431bb953201ae52dfb57211f4cbca57dcea0c7d9" type="text">' +
			'<label class="mdl-textfield__label" for="1c3011bf1b9427a4a9ed9b7d431bb953201ae52dfb57211f4cbca57dcea0c7d9">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_fop_mail_host_box_dir_email_thread_email_email', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_fop_mail_host_box_dir_email_thread_email_email_orig'] = '';
					delete query['filter_fop_mail_host_box_dir_email_thread_email_email'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadfop_mail_host_box_dir_email_thread_email();
					
				} else {
					$('#table_fop_mail_host_box_dir_email_thread_email').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_fop_mail_host_box_dir_email_thread_email_emailSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\Fop_mail_host_box_dir_email_thread_email::getfilter_fop_mail_host_box_dir_email_thread_email_emailItemsByStringAction('', $id));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_fop_mail_host_box_dir_email_thread_email_email_orig'] = '';
				delete query['filter_fop_mail_host_box_dir_email_thread_email_email'];
				reload('', items);reloadfop_mail_host_box_dir_email_thread_email();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_fop_mail_host_box_dir_email_thread_email_email', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_fop_mail_host_box_dir_email_thread_email_emailListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
    function changefilter_fop_mail_host_box_dir_email_thread_email_refemailListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_fop_mail_host_box_dir_email_thread_email_refemail', val, cb.checked);
		  } else {
			  delete query['filter_fop_mail_host_box_dir_email_thread_email_refemail'];
		  }reloadfop_mail_host_box_dir_email_thread_email();
        
    }

		var i1aa690f802f4e4d0029d35ed245cd7208dc9a00ab6fd4093e42605b3317829a8timeout = null;
		function changefilter_fop_mail_host_box_dir_email_thread_email_refemailSearchFilter(val, callback) {
			if(i1aa690f802f4e4d0029d35ed245cd7208dc9a00ab6fd4093e42605b3317829a8timeout) clearTimeout(i1aa690f802f4e4d0029d35ed245cd7208dc9a00ab6fd4093e42605b3317829a8timeout);

			i1aa690f802f4e4d0029d35ed245cd7208dc9a00ab6fd4093e42605b3317829a8timeout = setTimeout(function() {
				$.getJSON(reloadfop_mail_host_box_dir_email_thread_email({action: 'getfilter_fop_mail_host_box_dir_email_thread_email_refemailItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_fop_mail_host_box_dir_email_thread_email_refemail_orig'] = val;
				});
			}, 300);
		}

	function getfilter_fop_mail_host_box_dir_email_thread_email_refemailListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_fop_mail_host_box_dir_email_thread_email_refemail_orig']) ? json_encode($_GET['filter_fop_mail_host_box_dir_email_thread_email_refemail_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="1aa690f802f4e4d0029d35ed245cd7208dc9a00ab6fd4093e42605b3317829a8" type="text">' +
			'<label class="mdl-textfield__label" for="1aa690f802f4e4d0029d35ed245cd7208dc9a00ab6fd4093e42605b3317829a8">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_fop_mail_host_box_dir_email_thread_email_refemail', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_fop_mail_host_box_dir_email_thread_email_refemail_orig'] = '';
					delete query['filter_fop_mail_host_box_dir_email_thread_email_refemail'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadfop_mail_host_box_dir_email_thread_email();
					
				} else {
					$('#table_fop_mail_host_box_dir_email_thread_email').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_fop_mail_host_box_dir_email_thread_email_refemailSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\Fop_mail_host_box_dir_email_thread_email::getfilter_fop_mail_host_box_dir_email_thread_email_refemailItemsByStringAction('', $id));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_fop_mail_host_box_dir_email_thread_email_refemail_orig'] = '';
				delete query['filter_fop_mail_host_box_dir_email_thread_email_refemail'];
				reload('', items);reloadfop_mail_host_box_dir_email_thread_email();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_fop_mail_host_box_dir_email_thread_email_refemail', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_fop_mail_host_box_dir_email_thread_email_refemailListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
									
    function changefilter_fop_mail_host_box_dir_email_thread_email_emailListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_fop_mail_host_box_dir_email_thread_email_email', val, cb.checked);
		  } else {
			  delete query['filter_fop_mail_host_box_dir_email_thread_email_email'];
		  }reloadfop_mail_host_box_dir_email_thread_email();
        
    }

		var i1c3011bf1b9427a4a9ed9b7d431bb953201ae52dfb57211f4cbca57dcea0c7d9timeout = null;
		function changefilter_fop_mail_host_box_dir_email_thread_email_emailSearchFilter(val, callback) {
			if(i1c3011bf1b9427a4a9ed9b7d431bb953201ae52dfb57211f4cbca57dcea0c7d9timeout) clearTimeout(i1c3011bf1b9427a4a9ed9b7d431bb953201ae52dfb57211f4cbca57dcea0c7d9timeout);

			i1c3011bf1b9427a4a9ed9b7d431bb953201ae52dfb57211f4cbca57dcea0c7d9timeout = setTimeout(function() {
				$.getJSON(reloadfop_mail_host_box_dir_email_thread_email({action: 'getfilter_fop_mail_host_box_dir_email_thread_email_emailItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_fop_mail_host_box_dir_email_thread_email_email_orig'] = val;
				});
			}, 300);
		}

	function getfilter_fop_mail_host_box_dir_email_thread_email_emailListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_fop_mail_host_box_dir_email_thread_email_email_orig']) ? json_encode($_GET['filter_fop_mail_host_box_dir_email_thread_email_email_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="1c3011bf1b9427a4a9ed9b7d431bb953201ae52dfb57211f4cbca57dcea0c7d9" type="text">' +
			'<label class="mdl-textfield__label" for="1c3011bf1b9427a4a9ed9b7d431bb953201ae52dfb57211f4cbca57dcea0c7d9">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_fop_mail_host_box_dir_email_thread_email_email', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_fop_mail_host_box_dir_email_thread_email_email_orig'] = '';
					delete query['filter_fop_mail_host_box_dir_email_thread_email_email'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadfop_mail_host_box_dir_email_thread_email();
					
				} else {
					$('#table_fop_mail_host_box_dir_email_thread_email').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_fop_mail_host_box_dir_email_thread_email_emailSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\Fop_mail_host_box_dir_email_thread_email::getfilter_fop_mail_host_box_dir_email_thread_email_emailItemsByStringAction('', $id));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_fop_mail_host_box_dir_email_thread_email_email_orig'] = '';
				delete query['filter_fop_mail_host_box_dir_email_thread_email_email'];
				reload('', items);reloadfop_mail_host_box_dir_email_thread_email();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_fop_mail_host_box_dir_email_thread_email_email', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_fop_mail_host_box_dir_email_thread_email_emailListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
    function changefilter_fop_mail_host_box_dir_email_thread_email_refemailListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_fop_mail_host_box_dir_email_thread_email_refemail', val, cb.checked);
		  } else {
			  delete query['filter_fop_mail_host_box_dir_email_thread_email_refemail'];
		  }reloadfop_mail_host_box_dir_email_thread_email();
        
    }

		var i1aa690f802f4e4d0029d35ed245cd7208dc9a00ab6fd4093e42605b3317829a8timeout = null;
		function changefilter_fop_mail_host_box_dir_email_thread_email_refemailSearchFilter(val, callback) {
			if(i1aa690f802f4e4d0029d35ed245cd7208dc9a00ab6fd4093e42605b3317829a8timeout) clearTimeout(i1aa690f802f4e4d0029d35ed245cd7208dc9a00ab6fd4093e42605b3317829a8timeout);

			i1aa690f802f4e4d0029d35ed245cd7208dc9a00ab6fd4093e42605b3317829a8timeout = setTimeout(function() {
				$.getJSON(reloadfop_mail_host_box_dir_email_thread_email({action: 'getfilter_fop_mail_host_box_dir_email_thread_email_refemailItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_fop_mail_host_box_dir_email_thread_email_refemail_orig'] = val;
				});
			}, 300);
		}

	function getfilter_fop_mail_host_box_dir_email_thread_email_refemailListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_fop_mail_host_box_dir_email_thread_email_refemail_orig']) ? json_encode($_GET['filter_fop_mail_host_box_dir_email_thread_email_refemail_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="1aa690f802f4e4d0029d35ed245cd7208dc9a00ab6fd4093e42605b3317829a8" type="text">' +
			'<label class="mdl-textfield__label" for="1aa690f802f4e4d0029d35ed245cd7208dc9a00ab6fd4093e42605b3317829a8">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_fop_mail_host_box_dir_email_thread_email_refemail', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_fop_mail_host_box_dir_email_thread_email_refemail_orig'] = '';
					delete query['filter_fop_mail_host_box_dir_email_thread_email_refemail'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadfop_mail_host_box_dir_email_thread_email();
					
				} else {
					$('#table_fop_mail_host_box_dir_email_thread_email').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_fop_mail_host_box_dir_email_thread_email_refemailSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\Fop_mail_host_box_dir_email_thread_email::getfilter_fop_mail_host_box_dir_email_thread_email_refemailItemsByStringAction('', $id));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_fop_mail_host_box_dir_email_thread_email_refemail_orig'] = '';
				delete query['filter_fop_mail_host_box_dir_email_thread_email_refemail'];
				reload('', items);reloadfop_mail_host_box_dir_email_thread_email();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_fop_mail_host_box_dir_email_thread_email_refemail', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_fop_mail_host_box_dir_email_thread_email_refemailListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
									function updateNumberfop_mail_host_box_dir_email_thread_email(col) {
										//var checklist = window.DataViewChecked['fop_mail_host_box_dir_email_thread_email'][col];
										//if (checklist.id) {
											// checklist is online
											// TODO: check if cache is alive, otherwise reload from ajax, delay execution and return now
											//checklist.ranges = [[1,10000000]]; // mostly we use indirect idlists to tick all marks; so this is an approximation
										//}
										// checkboxes aktualisieren
										if (window.DataViewChecked && window.DataViewChecked['fop_mail_host_box_dir_email_thread_email'] && window.DataViewChecked['fop_mail_host_box_dir_email_thread_email'][col].ranges.length > 0) {
											$('.fop_mail_host_box_dir_email_thread_email__mass-action').css('visibility', 'visible');
											$('.fop_mail_host_box_dir_email_thread_email__action').css('visibility', 'hidden');
										} else {
											$('.fop_mail_host_box_dir_email_thread_email__mass-action').css('visibility', 'hidden');
											$('.fop_mail_host_box_dir_email_thread_email__action').css('visibility', 'visible');
										}
										$('.fop_mail_host_box_dir_email_thread_email__checkbox').each(function (idx, x) {
											for (var cssclass of x.classList) {
												if (cssclass.startsWith('fop_mail_host_box_dir_email_thread_email__checkbox-'+col+'-')) {
													var my_id = cssclass.substr(('fop_mail_host_box_dir_email_thread_email__checkbox-'+col+'-').length);
													if (window.DataViewChecked) {
														x.MaterialCheckbox[checklist.has(my_id) ? 'check' : 'uncheck']();
													}
												}
											}
										});
									}
									function reloadfop_mail_host_box_dir_email_thread_email (params, returnUrl, onlyScroll, addPadding = 0) {
										// copy query
										let nq = JSON.parse(JSON.stringify(query));
										nq['parent_request'] = <?php echo json_encode(strtok(\FOP\Util::getBackUrl(), '?')); ?>;
										<?php if (isset($_GET['select'])) { ?>nq['select'] = 'select';<?php } ?>
										nq["id"] = <?php echo json_encode($id); ?>; 
										if (params) {
											for (var i in params) nq[i] = params[i];
											var action = nq['action'];
											delete nq['action'];
											let querystr = "DataView/Fop_mail_host_box_dir_email_thread_email/" + action + "?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// direkt aufrufen (ist wohl ein Download oder so)
											if (returnUrl) return querystr;
											window.location.href = querystr;
										} else {
											let querystr;
											
											
											<?php if ((!\FOP\User::getIsGuest()) && (!\FOP\User::getIsGuest())) { ?>
											delete nq['action'];
											querystr = "DataView/Fop_mail_host_box_dir_email_thread_email/renderTabTable?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// per Ajax laden
											if(!$("#fop_mail_host_box_dir_email_thread_email-table")?.parent()?.parent()?.hasClass('fop-form-feature-collapsed') || $("#fop_mail_host_box_dir_email_thread_email-table")?.parent()?.parent()?.hasClass('fop-form-feature-mode-area')) {
											$.get(querystr, function(data){
												var tab = $("#fop_mail_host_box_dir_email_thread_email-table");
												var top = tab.find('.fop-table-body-inner');
												var el;
												if (onlyScroll && (el = $('<div class="tabcontent">' + data + '</div>').find('.fop-table-body-inner'))) {
													// nur Scroll-Bereich ersetzen
													var paddingTop = parseInt(el.css('paddingTop') || '0px', 10);
													var minHeight = parseInt(el.css('minHeight'), 10)
													paddingTop += addPadding;
													minHeight += addPadding;
													top.css({paddingTop: paddingTop.toString()+'px', minHeight: minHeight.toString()+'px'}); // Offset
													el = el.children();
													top.empty();
													top.append(el);
													el = top; // top-upgrade doppelt machen, dadurch vermeiden wir das Array-upgrade => Performance
												} else {
													// gesamten Tab ersetzen
													tab.children().remove();
													el = tab.html('<div class="tabcontent">' + data + '</div>');
												}
												try {
													for (var i = 0; i < el.length; i++) upgradeDOM(el[i]);
												} catch (e) {
													console.log(e);
												}
												upgradeTable(el.find('.fop-table .fop-table-header')); // Falls es Tabellen-Layout ist: Spalten-Order anpassen
												flushURL(); // Neue URL in Titelleiste eintragen

												// Checkbox-Auswahl ankreuzen
												updateNumberfop_mail_host_box_dir_email_thread_email('ID');
											});
											} else {
												// gesamten Tab ersetzen
												var tab = $("#fop_mail_host_box_dir_email_thread_email-table");
												tab.children().remove();
												el = tab.html('<div class="fop-lazy-reload" onclick="reloadfop_mail_host_box_dir_email_thread_email()"></div>');
											}
											<?php } ?>
											
										}
									}
									function checkfop_mail_host_box_dir_email_thread_email (id, col, checked) {
										// ID-Liste aufbauen
										if (!window.DataViewChecked) window.DataViewChecked = {};
										if (!window.DataViewChecked['fop_mail_host_box_dir_email_thread_email']) window.DataViewChecked['fop_mail_host_box_dir_email_thread_email'] = {};
										if (!window.DataViewChecked['fop_mail_host_box_dir_email_thread_email'][col]) window.DataViewChecked['fop_mail_host_box_dir_email_thread_email'][col] = new IDList();

										// Abfrage aller gecheckten IDs für eine Tabelle
										if (!id) {
											return window.DataViewChecked['fop_mail_host_box_dir_email_thread_email'][col].toString();
										}

										// check all, check id
										if (id == 'all') {
											// TODO: umbauen #1289: 'all' auch nur auf ne idlist reduzieren
											if (checked) {
												$.get(reloadfop_mail_host_box_dir_email_thread_email({action: 'getids', col: col}, true), function (ids) {
													window.DataViewChecked['fop_mail_host_box_dir_email_thread_email'][col] = new IDList(ids);
													updateNumberfop_mail_host_box_dir_email_thread_email(col);
												});
											} else {
												window.DataViewChecked['fop_mail_host_box_dir_email_thread_email'][col] = new IDList();
												updateNumberfop_mail_host_box_dir_email_thread_email(col);
											}
										} else {
											var ids = new IDList(id);
											var allcb = $('#fop_mail_host_box_dir_email_thread_email__all-checkbox');
											if (allcb[0]) {
												allcb[0].parentElement.MaterialCheckbox.uncheck(); // TODO: prüfen, ob Gruppen-CBs voll werden
											}
											if (checked == 'set') {
												window.DataViewChecked['fop_mail_host_box_dir_email_thread_email'][col] = ids;
											} else for (id of ids.all()) {
												if (checked) {
													window.DataViewChecked['fop_mail_host_box_dir_email_thread_email'][col].push(id);
												} else {
													window.DataViewChecked['fop_mail_host_box_dir_email_thread_email'][col].remove(id);
												}
											}
											updateNumberfop_mail_host_box_dir_email_thread_email(col);
										}
									}
								</script><?php

    
  }

  public static function renderSpecialFilters() { 
    
    
    // --- BLOCK: main ---
    ?>
	
	<script type"text/javascript">
		function updateSpecialFilter(param, val) {
			query[param] = val.toString();reloadfop_mail_host_box_dir_email_thread_email();
			
		}

	</script>
	<?php
	
    
  }

  public static function getSQL($params, $id) { 
    
    
    // --- BLOCK: main ---
    
								// returns a sql snippet 'FROM (...) AS t WHERE' where you can prepend your select clauses and append your ORDER LIMIT
								$sql = 'FROM (SELECT /* ID */ '.qi('ID').' AS '.qi('ID').',
									/* directory */ '.qi('directory').' AS '.qi('directory').',
									/* email */ '.qi('email').' AS '.qi('email').',
									/* email::canView */ '.qi('ref:email').'.'.qi('email:canView').' AS '.qi('email::canView').',
									/* email::description */ '.qi('ref:email').'.'.qi('email:description').' AS '.qi('email::description').',
									/* operation::create */ (FALSE) AS '.qi('operation::create').',
									/* operation::delete */ (FALSE) AS '.qi('operation::delete').',
									/* operation::edit */ (FALSE) AS '.qi('operation::edit').',
									/* operation::index */ ' . (!\FOP\User::getIsGuest() ? 1 : 0) . ' AS '.qi('operation::index').',
									/* operation::view */ '.(\FOP\User::getIsGuest() ? 'false' : 'true').' AS '.qi('operation::view').',
									/* position */ '.qi('position').' AS '.qi('position').',
									/* refemail */ (SELECT ('.qi('zb6Jv4wd').'.'.qi('ID').') FROM '.qi('fop_mail_host_box_dir_email').' '.qi('zb6Jv4wd').' WHERE '.qi('zb6Jv4wd').'.'.qi('uid').' = '.qi('fop_mail_host_box_dir_email_thread').'.'.qi('threadedemail').' AND (NOT (('.qi('zb6Jv4wd').'.'.qi('directory').') IS NULL)) LIMIT 1) AS '.qi('refemail').',
									/* refemail::canView */ '.qi('ref:refemail').'.'.qi('refemail:canView').' AS '.qi('refemail::canView').',
									/* refemail::description */ '.qi('ref:refemail').'.'.qi('refemail:description').' AS '.qi('refemail::description').',
									/* threadedemail */ '.qi('threadedemail').' AS '.qi('threadedemail').',
									1
								FROM '.qi('fop_mail_host_box_dir_email_thread').' '.qi('fop_mail_host_box_dir_email_thread').'
								LEFT JOIN (SELECT '.qi('ID').' AS '.qi('email:ID').', CONCAT((SELECT (CONCAT('.qi('CBD4eCc3').'.'.qi('display').', \' <\', '.qi('CBD4eCc3').'.'.qi('address').', \'>\')) FROM '.qi('fop_mail_host_box_dir_email_recipient').' '.qi('CBD4eCc3').' WHERE '.qi('CBD4eCc3').'.'.qi('email').' = '.qi('fop_mail_host_box_dir_email').'.'.qi('ID').' LIMIT 1), \' - \', '.qi('fop_mail_host_box_dir_email').'.'.qi('subject').', \' (\', '.(\FOP\Database::getDriver() == 'mysql' ? 'DATE_FORMAT(FROM_UNIXTIME' : 'to_char(to_timestamp') . '('.qi('fop_mail_host_box_dir_email').'.'.qi('timestamp').')' . ', '.\FOP\Database::sessionVarSQL('datetimeformat').'), \')\') AS '.qi('email:description').', (('.\FOP\Database::quote(\FOP\User::getIsLoggedIn()).') AND (COALESCE((SELECT (COALESCE((SELECT (CASE WHEN FALSE THEN TRUE ELSE NOT (('.qi('1IDxgk3w').'.'.qi('fopuser').') <> ('.\FOP\Database::sessionVarSQL('user').')) END) FROM '.qi('fop_mail_host_box').' '.qi('1IDxgk3w').' WHERE '.qi('1IDxgk3w').'.'.qi('ID').' = '.qi('p0EDqmbn').'.'.qi('mailbox').' LIMIT 1), FALSE)) FROM '.qi('fop_mail_host_box_dir').' '.qi('p0EDqmbn').' WHERE '.qi('p0EDqmbn').'.'.qi('ID').' = '.qi('fop_mail_host_box_dir_email').'.'.qi('directory').' LIMIT 1), FALSE))) AS '.qi('email:canView').' FROM '.qi('fop_mail_host_box_dir_email').') '.qi('ref:email').' ON '.qi('ref:email').'.'.qi('email:ID').' = '.qi('email').'
								LEFT JOIN (SELECT '.qi('ID').' AS '.qi('refemail:ID').', CONCAT((SELECT (CONCAT('.qi('CBD4eCc3').'.'.qi('display').', \' <\', '.qi('CBD4eCc3').'.'.qi('address').', \'>\')) FROM '.qi('fop_mail_host_box_dir_email_recipient').' '.qi('CBD4eCc3').' WHERE '.qi('CBD4eCc3').'.'.qi('email').' = '.qi('fop_mail_host_box_dir_email').'.'.qi('ID').' LIMIT 1), \' - \', '.qi('fop_mail_host_box_dir_email').'.'.qi('subject').', \' (\', '.(\FOP\Database::getDriver() == 'mysql' ? 'DATE_FORMAT(FROM_UNIXTIME' : 'to_char(to_timestamp') . '('.qi('fop_mail_host_box_dir_email').'.'.qi('timestamp').')' . ', '.\FOP\Database::sessionVarSQL('datetimeformat').'), \')\') AS '.qi('refemail:description').', (('.\FOP\Database::quote(\FOP\User::getIsLoggedIn()).') AND (COALESCE((SELECT (COALESCE((SELECT (CASE WHEN FALSE THEN TRUE ELSE NOT (('.qi('1IDxgk3w').'.'.qi('fopuser').') <> ('.\FOP\Database::sessionVarSQL('user').')) END) FROM '.qi('fop_mail_host_box').' '.qi('1IDxgk3w').' WHERE '.qi('1IDxgk3w').'.'.qi('ID').' = '.qi('p0EDqmbn').'.'.qi('mailbox').' LIMIT 1), FALSE)) FROM '.qi('fop_mail_host_box_dir').' '.qi('p0EDqmbn').' WHERE '.qi('p0EDqmbn').'.'.qi('ID').' = '.qi('fop_mail_host_box_dir_email').'.'.qi('directory').' LIMIT 1), FALSE))) AS '.qi('refemail:canView').' FROM '.qi('fop_mail_host_box_dir_email').') '.qi('ref:refemail').' ON '.qi('ref:refemail').'.'.qi('refemail:ID').' = (SELECT ('.qi('zb6Jv4wd').'.'.qi('ID').') FROM '.qi('fop_mail_host_box_dir_email').' '.qi('zb6Jv4wd').' WHERE '.qi('zb6Jv4wd').'.'.qi('uid').' = '.qi('fop_mail_host_box_dir_email_thread').'.'.qi('threadedemail').' AND (NOT (('.qi('zb6Jv4wd').'.'.qi('directory').') IS NULL)) LIMIT 1)
								WHERE ('.qi('email').' = ' . \FOP\Database::quote($id) . ')
									AND ('.(\FOP\User::getIsGuest() ? 'false' : 'true').')) AS t
								LEFT JOIN '.qi('fop_mail_host_box_dir_email').' AS '.qi('sorter-email').' ON t.'.qi('email').' = '.qi('sorter-email').'.'.qi('ID').'
								LEFT JOIN '.qi('fop_mail_host_box_dir_email').' AS '.qi('sorter-refemail').' ON t.'.qi('refemail').' = '.qi('sorter-refemail').'.'.qi('ID').'
								WHERE ' . (isset($params['range_min_fop_mail_host_box_dir_email_thread_email_threadedemail']) ? ($params['range_min_fop_mail_host_box_dir_email_thread_email_threadedemail'] !== '' && is_numeric($params['range_min_fop_mail_host_box_dir_email_thread_email_threadedemail']) ? 't.'.qi('threadedemail').' >= ' . \FOP\Database::quote($params['range_min_fop_mail_host_box_dir_email_thread_email_threadedemail']) . ' AND ' : '') : '') . 
								(isset($params['range_min_fop_mail_host_box_dir_email_thread_email_directory']) ? ($params['range_min_fop_mail_host_box_dir_email_thread_email_directory'] !== '' && is_numeric($params['range_min_fop_mail_host_box_dir_email_thread_email_directory']) ? 't.'.qi('directory').' >= ' . \FOP\Database::quote($params['range_min_fop_mail_host_box_dir_email_thread_email_directory']) . ' AND ' : '') : '') . 
								(isset($params['range_min_fop_mail_host_box_dir_email_thread_email_position']) ? ($params['range_min_fop_mail_host_box_dir_email_thread_email_position'] !== '' && is_numeric($params['range_min_fop_mail_host_box_dir_email_thread_email_position']) ? 't.'.qi('position').' >= ' . \FOP\Database::quote($params['range_min_fop_mail_host_box_dir_email_thread_email_position']) . ' AND ' : '') : '') . 
								(isset($params['range_max_fop_mail_host_box_dir_email_thread_email_threadedemail']) ? ($params['range_max_fop_mail_host_box_dir_email_thread_email_threadedemail'] !== '' && is_numeric($params['range_max_fop_mail_host_box_dir_email_thread_email_threadedemail']) ? 't.'.qi('threadedemail').' <= ' . \FOP\Database::quote($params['range_max_fop_mail_host_box_dir_email_thread_email_threadedemail']) . ' AND ' : '') : '') . 
								(isset($params['range_max_fop_mail_host_box_dir_email_thread_email_directory']) ? ($params['range_max_fop_mail_host_box_dir_email_thread_email_directory'] !== '' && is_numeric($params['range_max_fop_mail_host_box_dir_email_thread_email_directory']) ? 't.'.qi('directory').' <= ' . \FOP\Database::quote($params['range_max_fop_mail_host_box_dir_email_thread_email_directory']) . ' AND ' : '') : '') . 
								(isset($params['range_max_fop_mail_host_box_dir_email_thread_email_position']) ? ($params['range_max_fop_mail_host_box_dir_email_thread_email_position'] !== '' && is_numeric($params['range_max_fop_mail_host_box_dir_email_thread_email_position']) ? 't.'.qi('position').' <= ' . \FOP\Database::quote($params['range_max_fop_mail_host_box_dir_email_thread_email_position']) . ' AND ' : '') : '') . 
								(isset($params['filter_fop_mail_host_box_dir_email_thread_email_email']) ? ($params['filter_fop_mail_host_box_dir_email_thread_email_email'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_mail_host_box_dir_email_thread_email_email']))->toSQL('t.'.qi('email').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_mail_host_box_dir_email_thread_email_threadedemail']) ? ($params['filter_fop_mail_host_box_dir_email_thread_email_threadedemail'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_mail_host_box_dir_email_thread_email_threadedemail']))->toSQL('t.'.qi('threadedemail').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_mail_host_box_dir_email_thread_email_directory']) ? ($params['filter_fop_mail_host_box_dir_email_thread_email_directory'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_mail_host_box_dir_email_thread_email_directory']))->toSQL('t.'.qi('directory').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_mail_host_box_dir_email_thread_email_position']) ? ($params['filter_fop_mail_host_box_dir_email_thread_email_position'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_mail_host_box_dir_email_thread_email_position']))->toSQL('t.'.qi('position').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_mail_host_box_dir_email_thread_email_refemail']) ? ($params['filter_fop_mail_host_box_dir_email_thread_email_refemail'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_mail_host_box_dir_email_thread_email_refemail']))->toSQL('t.'.qi('refemail').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_mail_host_box_dir_email_thread_email_ID']) ? ($params['filter_fop_mail_host_box_dir_email_thread_email_ID'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_mail_host_box_dir_email_thread_email_ID']))->toSQL('t.'.qi('ID').'') . ') AND ') : '') : '') . 
								'
								 TRUE ';
								return $sql;
	
    
  }

  public static function getidsAction($col, $id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
			$q = \FOP\Database::query('SELECT t.'.qi($col).' '.self::getSQL($_GET, $id));
			$result = new \FOP\IDList();
			while ($item = $q->fetchColumn()) {
				$result->push($item);
			}
			die($result->toString());

    
  }

  public static function permissionsAction($id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		$ids = new \FOP\IDList($id);
		header('Content-Type: application/json');
		
		$perms = \FOP\Database::query('SELECT COUNT(*) AS __cnt, SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filteronly').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterrange').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterall').', SUM(CASE ((FALSE)) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('delete').' FROM '.qi('fop_mail_host_box_dir_email_thread').' WHERE ' . $ids->toSQL(qi('ID')))->fetch(\PDO::FETCH_ASSOC);
		
		return $perms;
	
    
  }

  public static function getfilter_fop_mail_host_box_dir_email_thread_email_emailItemsByStringAction($fstr, $id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		// Auf aktive DataView-Items einschränken
		$params = $_GET;
		unset($params['filter_fop_mail_host_box_dir_email_thread_email_email']);
		return \Types\Fop_mail_host_box_dir_email::getItems(null, -1, $fstr, ''.qi('ID').' IN (SELECT DISTINCT t.'.qi('email').''.self::getSQL($params, $id).')');
	

    
  }

  public static function getfilter_fop_mail_host_box_dir_email_thread_email_refemailItemsByStringAction($fstr, $id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		// Auf aktive DataView-Items einschränken
		$params = $_GET;
		unset($params['filter_fop_mail_host_box_dir_email_thread_email_refemail']);
		return \Types\Fop_mail_host_box_dir_email::getItems(null, -1, $fstr, ''.qi('ID').' IN (SELECT DISTINCT t.'.qi('refemail').''.self::getSQL($params, $id).')');
	

    
  }

  public static function getData($sqladdon, $params, $id, $stream = false ) { 
    
    
    // --- BLOCK: main ---
    
								$sql = self::getSQL($params, $id);

								$order = (\FOP\Util::array_value(array(
									'email ASC' => 'ORDER BY '.qi('sorter-email').'.'.qi('timestamp').' DESC, '.qi('sorter-email').'.'.qi('timestamp').' DESC, '.qi('sorter-email').'.'.qi('timestamp').' DESC, '.qi('sorter-email').'.'.qi('timestamp').' DESC, '.qi('sorter-email').'.'.qi('timestamp').' DESC',
									'refemail ASC' => 'ORDER BY '.qi('sorter-refemail').'.'.qi('timestamp').' DESC, '.qi('sorter-refemail').'.'.qi('timestamp').' DESC',
									'email DESC' => 'ORDER BY '.qi('sorter-email').'.'.qi('timestamp').' ASC, '.qi('sorter-email').'.'.qi('timestamp').' ASC, '.qi('sorter-email').'.'.qi('timestamp').' ASC, '.qi('sorter-email').'.'.qi('timestamp').' ASC, '.qi('sorter-email').'.'.qi('timestamp').' ASC',
									'refemail DESC' => 'ORDER BY '.qi('sorter-refemail').'.'.qi('timestamp').' ASC, '.qi('sorter-refemail').'.'.qi('timestamp').' ASC',
									'threadedemail ASC' => 'ORDER BY t.'.qi('threadedemail').' ASC',
									'directory ASC' => 'ORDER BY t.'.qi('directory').' ASC',
									'position ASC' => 'ORDER BY t.'.qi('position').' ASC',
									'threadedemail DESC' => 'ORDER BY t.'.qi('threadedemail').' DESC',
									'directory DESC' => 'ORDER BY t.'.qi('directory').' DESC',
									'position DESC' => 'ORDER BY t.'.qi('position').' DESC',
									'' => ''), isset($params['sort_fop_mail_host_box_dir_email_thread_email']) ? $params['sort_fop_mail_host_box_dir_email_thread_email'] : '') ?: 'ORDER BY '.qi('t').'.'.qi('position').' DESC');
								// wenn sqladdon bereits ein ORDER enthält, kein order aufbauen
								if (strpos($sqladdon, 'ORDER') !== false) {
									$order = '';
								}
								if ($stream) {
									// als Stream (währenddessen darf keine weitere SQL-Query laufen) für große Datenmengen und Statistiken
									$result = (function () use ($sql, $order, $sqladdon) {
										$stream = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
										while ($item = $stream->fetch(\PDO::FETCH_ASSOC)) {
											$item['email'] = \FOP\Sanitizers::null_converter($item['email']);
											$item['threadedemail'] = \Types\Integer::unpack($item['threadedemail']);
											$item['directory'] = \Types\Integer::unpack($item['directory']);
											$item['position'] = \Types\Integer::unpack($item['position']);
											$item['refemail'] = \FOP\Sanitizers::null_converter($item['refemail']);
											
											yield $item;
										}
									})();
								} else {
									// als RAM-Array
									$result = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
									$arr = $result->fetchAll(\PDO::FETCH_ASSOC);
									$itemcount = count($arr);

									foreach($arr as $i => &$item){
										$item['email'] = \FOP\Sanitizers::null_converter($item['email']);
										$item['threadedemail'] = \Types\Integer::unpack($item['threadedemail']);
										$item['directory'] = \Types\Integer::unpack($item['directory']);
										$item['position'] = \Types\Integer::unpack($item['position']);
										$item['refemail'] = \FOP\Sanitizers::null_converter($item['refemail']);
										
									}
									unset($item);

									$result = ["items" => $arr, "itemcount" => $itemcount];

									
								}

								return $result;
	
    
  }

  public static function getFilterHTML($params, $delimiter = ', ' , $showButton = true ) { 
    
    
    // --- BLOCK: main ---
    
		// Contract: ist showButton == false, sollten keine HTML-Tags im Output enthalten sein (Verwendung in Dateinamen!!)
		$filters = [];
		
	if (isset($params['range_min_fop_mail_host_box_dir_email_thread_email_threadedemail']) && isset($params['range_max_fop_mail_host_box_dir_email_thread_email_threadedemail'])) {
		array_push($filters, _('Relatierte EMail') . ': ' . (\Types\Integer::print($params['range_min_fop_mail_host_box_dir_email_thread_email_threadedemail'])
	) . ' ' . _('filters_between') . ' ' . (\Types\Integer::print($params['range_max_fop_mail_host_box_dir_email_thread_email_threadedemail'])
	));
	} else if (isset($params['range_min_fop_mail_host_box_dir_email_thread_email_threadedemail'])) {
		array_push($filters, _('Relatierte EMail') . ': ' . _('filters_from') . ' ' . (\Types\Integer::print($params['range_min_fop_mail_host_box_dir_email_thread_email_threadedemail'])
	));
	} else if (isset($params['range_max_fop_mail_host_box_dir_email_thread_email_threadedemail'])) {
		array_push($filters, _('Relatierte EMail') . ': ' . _('filters_to') . ' ' . (\Types\Integer::print($params['range_max_fop_mail_host_box_dir_email_thread_email_threadedemail'])
	));
	}
	if (isset($params['range_min_fop_mail_host_box_dir_email_thread_email_directory']) && isset($params['range_max_fop_mail_host_box_dir_email_thread_email_directory'])) {
		array_push($filters, _('Ordner') . ': ' . (\Types\Integer::print($params['range_min_fop_mail_host_box_dir_email_thread_email_directory'])
	) . ' ' . _('filters_between') . ' ' . (\Types\Integer::print($params['range_max_fop_mail_host_box_dir_email_thread_email_directory'])
	));
	} else if (isset($params['range_min_fop_mail_host_box_dir_email_thread_email_directory'])) {
		array_push($filters, _('Ordner') . ': ' . _('filters_from') . ' ' . (\Types\Integer::print($params['range_min_fop_mail_host_box_dir_email_thread_email_directory'])
	));
	} else if (isset($params['range_max_fop_mail_host_box_dir_email_thread_email_directory'])) {
		array_push($filters, _('Ordner') . ': ' . _('filters_to') . ' ' . (\Types\Integer::print($params['range_max_fop_mail_host_box_dir_email_thread_email_directory'])
	));
	}
	if (isset($params['range_min_fop_mail_host_box_dir_email_thread_email_position']) && isset($params['range_max_fop_mail_host_box_dir_email_thread_email_position'])) {
		array_push($filters, _('Positon') . ': ' . (\Types\Integer::print($params['range_min_fop_mail_host_box_dir_email_thread_email_position'])
	) . ' ' . _('filters_between') . ' ' . (\Types\Integer::print($params['range_max_fop_mail_host_box_dir_email_thread_email_position'])
	));
	} else if (isset($params['range_min_fop_mail_host_box_dir_email_thread_email_position'])) {
		array_push($filters, _('Positon') . ': ' . _('filters_from') . ' ' . (\Types\Integer::print($params['range_min_fop_mail_host_box_dir_email_thread_email_position'])
	));
	} else if (isset($params['range_max_fop_mail_host_box_dir_email_thread_email_position'])) {
		array_push($filters, _('Positon') . ': ' . _('filters_to') . ' ' . (\Types\Integer::print($params['range_max_fop_mail_host_box_dir_email_thread_email_position'])
	));
	}if (isset($params['filter_fop_mail_host_box_dir_email_thread_email_threadedemail'])) {
		if ($params['filter_fop_mail_host_box_dir_email_thread_email_threadedemail'] == '_null') {
			array_push($filters, _('Relatierte EMail') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_mail_host_box_dir_email_thread_email_threadedemail']))->all() AS $val) {
				$value = \Types\Integer::print($val)
	;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Relatierte EMail') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_mail_host_box_dir_email_thread_email_directory'])) {
		if ($params['filter_fop_mail_host_box_dir_email_thread_email_directory'] == '_null') {
			array_push($filters, _('Ordner') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_mail_host_box_dir_email_thread_email_directory']))->all() AS $val) {
				$value = \Types\Integer::print($val)
	;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Ordner') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_mail_host_box_dir_email_thread_email_position'])) {
		if ($params['filter_fop_mail_host_box_dir_email_thread_email_position'] == '_null') {
			array_push($filters, _('Positon') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_mail_host_box_dir_email_thread_email_position']))->all() AS $val) {
				$value = \Types\Integer::print($val)
	;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Positon') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_mail_host_box_dir_email_thread_email_email'])) {
		if ($params['filter_fop_mail_host_box_dir_email_thread_email_email'] == '_null') {
			array_push($filters, _('E-Mail') . ': ' . _(''));
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_mail_host_box_dir_email_thread_email_email']))->all() AS $val) {
				$value = 
  \FOP\Database::query('SELECT CONCAT((SELECT (CONCAT('.qi('CBD4eCc3').'.'.qi('display').', \' <\', '.qi('CBD4eCc3').'.'.qi('address').', \'>\')) FROM '.qi('fop_mail_host_box_dir_email_recipient').' '.qi('CBD4eCc3').' WHERE '.qi('CBD4eCc3').'.'.qi('email').' = '.qi('fop_mail_host_box_dir_email').'.'.qi('ID').' LIMIT 1), \' - \', '.qi('fop_mail_host_box_dir_email').'.'.qi('subject').', \' (\', '.(\FOP\Database::getDriver() == 'mysql' ? 'DATE_FORMAT(FROM_UNIXTIME' : 'to_char(to_timestamp') . '('.qi('fop_mail_host_box_dir_email').'.'.qi('timestamp').')' . ', '.\FOP\Database::sessionVarSQL('datetimeformat').'), \')\') AS description FROM '.qi('fop_mail_host_box_dir_email').' WHERE '.qi('ID').' = ' . \FOP\Database::quote($val))->fetchColumn() ?: _('')
;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('E-Mail') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_mail_host_box_dir_email_thread_email_refemail'])) {
		if ($params['filter_fop_mail_host_box_dir_email_thread_email_refemail'] == '_null') {
			array_push($filters, _('Kommunikationsverlauf') . ': ' . _(''));
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_mail_host_box_dir_email_thread_email_refemail']))->all() AS $val) {
				$value = 
  \FOP\Database::query('SELECT CONCAT((SELECT (CONCAT('.qi('CBD4eCc3').'.'.qi('display').', \' <\', '.qi('CBD4eCc3').'.'.qi('address').', \'>\')) FROM '.qi('fop_mail_host_box_dir_email_recipient').' '.qi('CBD4eCc3').' WHERE '.qi('CBD4eCc3').'.'.qi('email').' = '.qi('fop_mail_host_box_dir_email').'.'.qi('ID').' LIMIT 1), \' - \', '.qi('fop_mail_host_box_dir_email').'.'.qi('subject').', \' (\', '.(\FOP\Database::getDriver() == 'mysql' ? 'DATE_FORMAT(FROM_UNIXTIME' : 'to_char(to_timestamp') . '('.qi('fop_mail_host_box_dir_email').'.'.qi('timestamp').')' . ', '.\FOP\Database::sessionVarSQL('datetimeformat').'), \')\') AS description FROM '.qi('fop_mail_host_box_dir_email').' WHERE '.qi('ID').' = ' . \FOP\Database::quote($val))->fetchColumn() ?: _('')
;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Kommunikationsverlauf') . ': ' . implode(', ', $values));
		}
	}
		if (count($filters)) {
			$result = implode($delimiter, array_map(function ($filter) {
				if (is_array($filter)) {
					return implode('', $filter);
				}
				return htmlentities($filter);
			}, $filters))
			// Button, um Filter zu entfernen
			. ($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="for (var q in query) {if (q.includes(\'_fop_mail_host_box_dir_email_thread_email_\')) delete query[q];} reloadfop_mail_host_box_dir_email_thread_email(); ">clear</i>' : '');
		} else {
			$result = _('no_filter');
		}
		return $result;
	
    
  }

  public static function openAction($fop_table, $fop_id, $fop_from, $id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    

if ($fop_table == 'fop_mail_host_box_dir_email_thread') {
	\FOP\Session::setPayload('dv-fop_mail_host_box_dir_email_thread', [
		'id' => 'fop_mail_host_box_dir_email_thread_email',
		'tbl' => 'fop_mail_host_box_dir_email_thread',
		'idcol' => 'ID',
		'prev' => \DataViewRouter\Fop_mail_host_box_dir_email_thread_email::stepURL('fop_mail_host_box_dir_email_thread', 'XXX', -1),
		'next' => \DataViewRouter\Fop_mail_host_box_dir_email_thread_email::stepURL('fop_mail_host_box_dir_email_thread', 'XXX',  1),
		'from' => $fop_from,
		'param_id' => $id
	]);
	
	if ($fop_id == '_') return; // nur Rückreferenz setzen, nicht öffnen
	$params = [];
	if (isset($_GET['popup'])) $params['popup'] = true;
	if (isset($_GET['from'])) $params['from'] = $_GET['from'];
	$params['id'] = $fop_id;
	
	$url = \TablesRouter\Fop_mail_host_box_dir_email_thread::viewURL2($params);
	header('Location: ' . $url);
}

die();
    
  }

  public static function stepAction($tbl, $id, $step) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
	$dv = \FOP\Session::getPayload('dv-'.$tbl);
	$url = $dv['from'];
	$parts = parse_url($url);
	parse_str($parts['query'], $query);
	$data = self::getData('', $query, $dv['param_id']);
	$col = $dv['idcol'];
	$ids = array_map(function ($x) use ($col) {return $x[$col];}, $data['items']);
	if (!count($ids)) {
		header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])));
		die();
	}
	$idx = array_search($id, $ids);
	$idx += count($ids) + $step;
	$idx = $idx % count($ids);
	header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])) . '/view?id=' . urlencode($ids[$idx]));
	die();

    
  }


  
  

  
  
}



